players = {}
bullets = {}
powerUps = {}
particles = {}
nbPlayers = 26
timer = 0
math.randomseed(os.time())

function love.load()
	img = love.graphics.newCanvas(5, 5)
  love.graphics.setCanvas(img)
    love.graphics.setColor(1, 1, 1, 1)
    love.graphics.circle("fill", 2.5, 2.5, 2.5)
  love.graphics.setCanvas()
  
  font = love.graphics.getFont()
  windowWidth, windowHeight = love.graphics.getDimensions()
  for i=1,nbPlayers do
    table.insert(players, {x = math.random(100, windowWidth-100), y = math.random(100, windowHeight-100), r = math.random(200)/100*math.pi, powerUp = 0, timer = 0, letter = randomLetter(), heat = 0, color = {math.random(), math.random(), math.random()}})
    local ok = false
    while not ok do
      ok = true
      players[i].letter = randomLetter()
      for j,v in ipairs(players)do
        if j ~= i and v.letter == players[i].letter then ok = false end
      end
    end
    print(players[i].letter)
  end
end

function love.update(dt)
  touches = love.touch.getTouches()
  timer = timer + 1/60
  if timer >= #players*5/4 then
    table.insert(powerUps, {x = math.random(100, windowWidth-100), y = math.random(100, windowHeight-100), v = math.random(7), r = math.random(200)/100*math.pi})
    timer = 0
  end
  for i,v in ipairs(particles) do
    v.ps:update(1/60)
    if not v.ps:isActive() and v.ps:getCount() == 0 then table.remove(particles, i) end 
  end
  for i,v in ipairs(players) do
    if v.powerUp == 6 then
      local target = math.random(#players)
      local x, y = v.x, v.y
      v.x, v.y = players[target].x, players[target].y
      players[target].x, players[target].y = x, y
      v.timer = 0
      local psystem = love.graphics.newParticleSystem(img, 100)
      psystem:setParticleLifetime(1, 2)
      psystem:setEmissionRate(50)
      psystem:setSpread(math.pi*2)
      psystem:setSpeed(-40, 40)
      psystem:setColors(0, 1, 1, 1, 0, 1, 1, 0)
      psystem:setEmitterLifetime(1)
      table.insert(particles, {ps = psystem, x = v.x, y = v.y})
      table.insert(particles, {ps = psystem, x = players[target].x, y = players[target].y})
    end
    if v.powerUp == 7 then
      for j=1,4 do
        table.insert(bullets, {x = v.x, y = v.y, o = i, r = (j/2)*math.pi+v.r})
      end
      v.timer = 0
    end
    if v.powerUp == 2 then v.heat = v.heat - 1/3 else v.heat = v.heat - 1/6 end
    if v.heat < 0 then v.heat = 0 end
    if v.timer > 0 then v.timer = v.timer - 1/60 else v.powerUp = 0 end
    if v.powerUp == 3 then
      v.x = v.x + 6*math.cos(v.r)
      v.y = v.y + 6*math.sin(v.r)
    else
      v.x = v.x + 3*math.cos(v.r)
      v.y = v.y + 3*math.sin(v.r)
    end
    if v.x < 100 then 
      v.r = math.pi - v.r 
      v.x = 100
    end
    if v.y < 100 then 
      v.r = - v.r 
      v.y = 100
    end
    if v.x > windowWidth - 100 then 
      v.r = math.pi - v.r 
      v.x = windowWidth - 100
    end
    if v.y > windowHeight - 100 then 
      v.r = - v.r 
      v.y = windowHeight - 100
    end
    if love.keyboard.isDown(v.letter) and v.heat < 100 then if v.powerUp == 1 then v.r = v.r - math.pi/60 else v.r = v.r + math.pi/60 end end
    for j,w in ipairs(touches) do
      local x, y = love.touch.getPosition(w)
      if x >= (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and x <= i/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and y >= math.floor((i*2-2)/#players)*windowHeight/2 and y <= math.floor((i*2-2)/#players+1)*windowHeight/2 and v.heat < 100 then 
        if v.powerUp == 1 then v.r = v.r - math.pi/60 else v.r = v.r + math.pi/60 end
        break
      end
    end
    for j,w in ipairs(powerUps) do
      if math.sqrt((v.x - w.x)^2 + (v.y - w.y)^2) < 15 and v.powerUp == 0 then
        v.powerUp = w.v
        v.timer = 5
        table.remove(powerUps, j)
      end
    end
    for j,w in ipairs(players) do
      if math.sqrt((v.x - w.x)^2 + (v.y - w.y)^2) < 20 and j ~= i then
        local r = math.atan2(v.y - w.y, v.x - w.x)
        v.r = r
        w.r = r + math.pi
      end
    end
  end
  for i,v in ipairs(bullets) do
    if v.o <= #players then
      if players[v.o].powerUp == 5 then
        v.x = v.x + 10*math.cos(v.r)
        v.y = v.y + 10*math.sin(v.r)
      else
        v.x = v.x + 5*math.cos(v.r)
        v.y = v.y + 5*math.sin(v.r)
      end
      if players[v.o].powerUp == 4 then
        if v.x < 100 then 
          v.r = math.pi - v.r 
          v.x = 100
        end
        if v.y < 100 then 
          v.r = - v.r 
          v.y = 100
        end
        if v.x > windowWidth - 100 then 
          v.r = math.pi - v.r 
          v.x = windowWidth - 100
        end
        if v.y > windowHeight - 100 then 
          v.r = - v.r 
          v.y = windowHeight - 100
        end
      elseif v.x < 100 or v.x > windowWidth-100 or v.y < 100 or v.y > windowHeight-100 then table.remove(bullets, i) end
    else
      if v.x < 100 or v.x > windowWidth-100 or v.y < 100 or v.y > windowHeight-100 then table.remove(bullets, i) end
      v.x = v.x + 5*math.cos(v.r)
      v.y = v.y + 5*math.sin(v.r)
    end
    local stop = false
    for j,w in ipairs(players) do
      if math.sqrt((v.x - w.x)^2 + (v.y - w.y)^2) < 12 and v.o ~= j then
        local psystem = love.graphics.newParticleSystem(img, 100)
        psystem:setParticleLifetime(2, 5) -- Particles live at least 2s and at most 5s.
        psystem:setSpread(math.pi*2)
        psystem:setSpeed(-40, 40)
        psystem:setColors(w.color[1], w.color[2], w.color[3], 1, 1, 0, 0, 0) -- Fade to transparency.
        psystem:emit(50)
        psystem:stop()
        table.insert(particles, {ps = psystem, x = w.x, y = w.y})
        table.remove(players, j)
        table.remove(bullets, i)
        stop = true
        break
      end
    end
    if stop then break end
  end
end

function love.draw()
  for i,v in ipairs(particles) do
    love.graphics.draw(v.ps, v.x, v.y) 
  end
  for i,v in ipairs(players) do
    local normal = true
    for j,w in ipairs(touches) do
      local x, y = love.touch.getPosition(w)
      if v.heat < 100 then 
        if x >= (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and x <= i/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and y >= math.floor((i*2-2)/#players)*windowHeight/2 and y <= math.floor((i*2-2)/#players+1)*windowHeight/2 then 
          love.graphics.setColor(1, 1, 1, 1)
          love.graphics.rectangle("fill", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
          love.graphics.setColor(0, 0, 0, 1)
          love.graphics.print(v.letter, (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*(windowHeight-15))
          love.graphics.rectangle("line", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
          normal = false
        end
      else
        love.graphics.setColor(1, 0, 0, 1)
        love.graphics.rectangle("fill", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
        love.graphics.setColor(0, 0, 0, 1)
        love.graphics.print(v.letter, (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*(windowHeight-15))
        love.graphics.rectangle("line", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
      end
    end
    if normal and v.heat < 100 then
      love.graphics.setColor(1, 1, 1, 1)
      love.graphics.rectangle("line", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
      love.graphics.print(v.letter, (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*(windowHeight-15))
    elseif normal then
      love.graphics.setColor(1, 0, 0, 1)
      love.graphics.rectangle("fill", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
      love.graphics.setColor(0, 0, 0, 1)
      love.graphics.print(v.letter, (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*(windowHeight-15))
      love.graphics.rectangle("line", (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth, math.floor((i*2-2)/#players)*windowHeight/2, 1/#players*windowWidth*2, windowHeight/2)
    end
  end
  love.graphics.setColor(0, 0, 0, 1)
  love.graphics.rectangle("fill", 100, 100, windowWidth-200, windowHeight-200)
  love.graphics.setColor(1, 1, 1, 1)
  love.graphics.line(100, 100, windowWidth-100, 100)
  love.graphics.line(100, 100, 100, windowHeight-100)
  love.graphics.line(windowWidth-100, 100, windowWidth-100, windowHeight-100)
  love.graphics.line(100, windowHeight-100, windowWidth-100, windowHeight-100)
  for i,v in ipairs(players) do
    love.graphics.setColor(v.color[1], v.color[2], v.color[3], 1)
    love.graphics.line(v.x, v.y, v.x+20*math.cos(v.r), v.y+20*math.sin(v.r))
    love.graphics.circle("fill", v.x, v.y, 10)
    love.graphics.setColor((5-v.timer)/5, (100-v.heat)/100, (100-v.heat)/100*(5-v.timer)/5, 1-(100-v.heat)/100*(5-v.timer)/5)
    love.graphics.circle("line", v.x, v.y, 10)
    love.graphics.setColor(0, 0, 0, 1)
    love.graphics.print(v.letter, v.x, v.y, 0, 1, 1, font:getWidth(v.letter)/2, font:getHeight()/2)
  end
  for i,v in ipairs(bullets) do
    love.graphics.setColor(1, 1, 1, 1)
    love.graphics.circle("fill", v.x, v.y, 2)
  end
  for i,v in ipairs(powerUps) do
    v.x = v.x + .5*math.cos(v.r)
    v.y = v.y + .5*math.sin(v.r)
    if v.x < 100 then 
      v.r = math.pi - v.r 
      v.x = 100
    end
    if v.y < 100 then 
      v.r = - v.r 
      v.y = 100
    end
    if v.x > windowWidth - 100 then 
      v.r = math.pi - v.r 
      v.x = windowWidth - 100
    end
    if v.y > windowHeight - 100 then 
      v.r = - v.r 
      v.y = windowHeight - 100
    end
    local color = {0, 0, 0, 1}
    if v.v < 4 then color[v.v] = 1 elseif v.v < 6 then
      color[1] = 1
      color[v.v-2] = 1
    elseif v.v == 6 then color = {0, 1, 1, 1} else color = {1, 1, 1, 1} end
    love.graphics.setColor(color)
    love.graphics.circle('fill', v.x, v.y, 5)
    love.graphics.setColor(0, 0, 0, 1)
    love.graphics.print(v.v, v.x, v.y, 0, 1, 1, font:getWidth(v.v)/2, font:getHeight()/2)
  end
  love.graphics.setColor(1, 1, 1, 1)
  for i,v in ipairs(particles) do
    love.graphics.draw(v.ps, v.x, v.y)
  end
end

function love.keypressed(key, scan)
  for i,v in ipairs(players) do
    if key == v.letter and v.heat < 100 then 
      table.insert(bullets, {x = v.x, y = v.y, o = i, r = v.r})
      v.heat = v.heat + 20
    end
  end
end

function love.touchpressed(id, x, y)
  for i,v in ipairs(players) do
    if x >= (i-1)/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and x <= i/#players*windowWidth*2-math.floor((i*2-2)/#players)*windowWidth and y >= math.floor((i*2-2)/#players)*windowHeight/2 and y <= math.floor((i*2-2)/#players+1)*windowHeight/2 and v.heat < 100 then 
      table.insert(bullets, {x = v.x, y = v.y, o = i, r = v.r})
      v.heat = v.heat + 20
    end
  end
end

function love.lowmemory()
  love.errhand("Plus d'espace")
end

function randomLetter()
  return string.char(math.random(97, 122))
end